-- Local
local Keys = {
	["ESC"] = 322, ["F1"] = 288, ["F2"] = 289, ["F3"] = 170, ["F5"] = 166, ["F6"] = 167, ["F7"] = 168, ["F8"] = 169, ["F9"] = 56, ["F10"] = 57, 
	["~"] = 243, ["1"] = 157, ["2"] = 158, ["3"] = 160, ["4"] = 164, ["5"] = 165, ["6"] = 159, ["7"] = 161, ["8"] = 162, ["9"] = 163, ["-"] = 84, ["="] = 83, ["BACKSPACE"] = 177, 
	["TAB"] = 37, ["Q"] = 44, ["W"] = 32, ["E"] = 38, ["R"] = 45, ["T"] = 245, ["Y"] = 246, ["U"] = 303, ["P"] = 199, ["["] = 39, ["]"] = 40, ["ENTER"] = 18,
	["CAPS"] = 137, ["A"] = 34, ["S"] = 8, ["D"] = 9, ["F"] = 23, ["G"] = 47, ["H"] = 74, ["K"] = 311, ["L"] = 182,
	["LEFTSHIFT"] = 21, ["Z"] = 20, ["X"] = 73, ["C"] = 26, ["V"] = 0, ["B"] = 29, ["N"] = 249, ["M"] = 244, [","] = 82, ["."] = 81,
	["LEFTCTRL"] = 36, ["LEFTALT"] = 19, ["SPACE"] = 22, ["RIGHTCTRL"] = 70, 
	["HOME"] = 213, ["PAGEUP"] = 10, ["PAGEDOWN"] = 11, ["DELETE"] = 178,
	["LEFT"] = 174, ["RIGHT"] = 175, ["TOP"] = 27, ["DOWN"] = 173,
	["NENTER"] = 201, ["N4"] = 108, ["N5"] = 60, ["N6"] = 107, ["N+"] = 96, ["N-"] = 97, ["N7"] = 117, ["N8"] = 61, ["N9"] = 118
}

local anchorSlack = 0.5
local boatsWithAnchor = {
	"DINGHY",
	"DINGHY2",
	"DINGHY3",
	"DINGHY4",
	"JETMAX",
	"MARQUIS",
	"PREDATOR",
	"SPEEDER2",
	"SQUALO",
	"SUNTRAP",
	"TORO",
	"TORO2",
	"TROPIC",
	"TROPIC2",
	"TUG",
	"DEFENDER"
}
local adjusting = false


local boatsAnchored = {}
Citizen.CreateThread(function()
	while true do
		Citizen.Wait(0)
		local ped = GetPlayerPed(-1)
		if IsPedInAnyVehicle(ped, true) then
			local veh = GetVehiclePedIsIn(ped)	
			local vehName = GetDisplayNameFromVehicleModel(GetEntityModel(veh))					
			if veh ~= nil and ped == GetPedInVehicleSeat(veh, -1) and has_value(boatsWithAnchor, vehName) ~= 0 then
				if IsControlPressed(1, Keys["LEFTCTRL"]) then
					if IsControlJustReleased(1, Keys["LEFTSHIFT"]) then
						local i = isBoatAnchored(boatsAnchored, veh)
						if i > 0 then														
							table.remove(boatsAnchored,i)												
						else													
							local anchorCoords = GetEntityCoords(veh, true)
							table.insert(boatsAnchored,{boat=veh,a=anchorCoords})
						end						
					end	
				end
				if isBoatAnchored(boatsAnchored, veh) > 0 then
					displayIndicator(true)	
				else
					displayIndicator(false)	
				end
			end
		end			
	end
end)

Citizen.CreateThread(function()	
	while true do
		Citizen.Wait(0)		
		if tablelength(boatsAnchored) > 0 then
			local ped = GetPlayerPed(-1)
			for k,v in pairs(boatsAnchored) do
				local vCoords = GetEntityCoords(v.boat, true)	
				if vCoords.x > v.a.x + anchorSlack  and adjusting == false then					
					SetEntityCoordsNoOffset(v.boat, v.a.x + anchorSlack, vCoords.y, vCoords.z, 1, 0, 0)					
				end
				if vCoords.x < v.a.x - anchorSlack then					
					SetEntityCoordsNoOffset(v.boat, v.a.x - anchorSlack, vCoords.y, vCoords.z, 1, 0, 0)					
				end
				if vCoords.y > v.a.y + anchorSlack then					
					SetEntityCoordsNoOffset(v.boat, vCoords.x, v.a.y + anchorSlack, vCoords.z, 1, 0, 0)					
				end
				if vCoords.y < v.a.y - anchorSlack then				
					SetEntityCoordsNoOffset(v.boat, vCoords.x, v.a.y - anchorSlack, vCoords.z, 1, 0, 0)					
				end	

				--remove anchor if someone else takes control of the boat
				
				if GetPedInVehicleSeat(v.boat, -1) ~= ped and GetPedInVehicleSeat(v.boat, -1) ~= 0 then
					table.remove(boatsAnchored,k)
				end
			end	
		end
	end
end)

function displayIndicator(isOn)
	SetTextFont(0)
	SetTextProportional(0)
	SetTextScale(0.3, 0.3)
	if isOn then
		SetTextColour(255, 100, 0, 255)
	else
		SetTextColour(255, 255, 255, 255)
	end
	SetTextEntry("STRING")
	AddTextComponentString("Anchor")
	DrawText(0.22, 0.78)
end


function tablelength(T)
  local count = 0
  for _ in pairs(T) do count = count + 1 end
  return count
end

function isBoatAnchored (tab, val)
    for index, value in ipairs(tab) do
        if value.boat == val then
            return index
        end
    end
    return 0
end

function has_value (tab, val)
    for index, value in ipairs(tab) do
        if value == val then
            return index
        end
    end
    return 0
end
